/*
 * buffer.cpp
 *
 *  Created on: 14-lug-2009
 *      Author: gio
 */

#include <JTC/jtc.h>

#define LEN 40

template <class T>
class Buffer : public JTCMonitor

{
	T thebuffer[LEN];
	int in;
	int out;
	int chars;
	bool open;

public:
	Buffer(T initValue)
	{
		in = 0;
		out = 0;
		chars = 0;
		for(int i = 0; i < LEN; i++)
			thebuffer[i] = initValue;
	    open = true;
	}

	void close()
	{
		JTCSynchronized sync(*this);
		open = false;
		/*
		 * Notifica eventuali Worker in wait che il buffer  chiuso.
		 */
		notifyAll();
	}

	T get()
	{
		JTCSynchronized sync(*this);
		while (chars == 0 && open) {
			wait();
		}
		chars--;
		T c = thebuffer[out];
		out = ( out + 1 ) % LEN;
		notify();
	    /*
	     * Se il buffer  'chiuso' la get fallisce e ritorna null.
	     */
		return open ? c : NULL;
	}

	void put(T c)
	{
		JTCSynchronized sync(*this);
		while (chars == LEN) {
			wait();
		}
		chars++;
        thebuffer[in] = c;
		in = (in + 1) % LEN;
		notify();
	}
};

